<template>
  <single-pane :capt="dictionaryRu.title">
    <ob-table
      :columns="columnsObTable"
      :functionalPanel="true"
      :remote-opt="getObTableData"
      :show-add-button="true"
      is-fixed-header
      @select="onSelection"
      @add="onAdd"
      ref="obTable"
    />
    <ObModal
      ref="viewItem"
      :title="newStatus ? 'Добавление температурного регистратора' : 'Температурный регистратор'"
      custom-class="modal-medium"
      :is-show-pagination="!newStatus"
      :data-grid="$refs.dataGrid"
      :is-show-controls="false"
    >
      <TemperatureRecorder
        :data-source="selectedData"
        :tracking-methods="trackingMethods"
        :api="api"
        @delete="onDelete"
        @submit="preparedSave"
        @refresh="onRefresh"
      />
    </ObModal>
  </single-pane>
</template>

<script>
import api from "@/api";
import SinglePane from "common-components/src/obComponents/obSinglePanels";
import paging from "@/mixins/dictionaries/paging";
import itemMixin from "@/mixins/dictionaries/edit-item";
import models from "@/models";
import TemperatureRecorder from "./modal/TemperatureRecorder";
import ObModal from "common-components/src/obComponents/obModal";
import ObTable from "common-components/src/obComponents/obTable";
import { dictionaryDefault } from '@/translations/ru/default';
import { dictionary } from '@/translations/ru/dictionaries__temperature__temperature_recorders';

export default {
  name: "TemperatureRecorders",
  components: {
    ObModal,
    ObTable,
    SinglePane,
    TemperatureRecorder
  },
  mixins: [paging, itemMixin],
  computed: {
    formModel() {
      return models.temperatureRecorder.add;
    },
    columnsObTable() {
      return [
        {
          title: this.dictionaryRu.columns.denomination,
          key: "denomination"
        },
        {
          title: this.dictionaryRu.columns.tracker_denomination,
          width: 170,
          key: "tracker_denomination",
          html: (data) => {
            return data.tracker && data.tracker.uuid
              ? data.tracker.denomination
              : `<span class="inactive">${this.dictionaryRu.columns.no_tracker}</span>`;
          }
        },
        {
          title: this.dictionaryRu.columns.description,
          key: "description"
        },
        {
          title: this.dictionaryRu.columns.status,
          width: 110,
          key: "is_active",
          html: (data) => {
            return !data.is_active ? this.dictionaryRu.status.inactive : this.dictionaryRu.status.active;
          }
        }
      ];
    }
  },
  data() {
    return {
      dictionaryRu: Object.assign(dictionary, dictionaryDefault),
      dataGridRefName: "TemperatureRecorders",
      titles: ["регистратор", "регистратора", "регистраторов"],
      trackingMethods: [],
      api: {
        source: "oboz2-dictionary-temperature-recorders-crud/v1/"
      }
    }
  },
  methods: {
    async loadTrackingMethods() {
      api.general
        .getTrackingMethods(false)
        .then(({ data }) => {
          if (!data || data.error) {
            this.$notification({
              type: "system_notification_error",
              message: "Ошибка загрузки методов отслеживания"
            });
          } else {
            this.trackingMethods = data.content;
          }
        })
        .catch(() => {
          this.$notification({
            type: "system_notification_error",
            message: "Ошибка загрузки методов отслеживания"
          });
        });
    },
    preparedSave(payload) {
      this.onSave(payload);
    }
  },
  mounted() {
    this.loadTrackingMethods();
  }
}
</script>

<style scoped>
</style>
